

#ifndef  __CONFIGUREDAYSSTATE_H__
#define  __CONFIGUREDAYSSTATE_H__


#include "State.H"
#include "SharedData.H"
#include "Keypad.H"
#include "SevenSegments.H"
#include "Stepper.H"


extern "C++" {
    namespace avelino {
        using namespace std;

        class ConfigureDaysState : public State<SharedData> {
            protected:
                Keypad &keypad;
                SevenSegments &sevenSegments;
                Stepper &stepper;
                State<SharedData> *nextState;
                SharedData *data;
                bool configureButtonPressed;
            public:
                ConfigureDaysState(Keypad &keypad, SevenSegments &sevenSegments, Stepper &stepper);
                void setNextState(State<SharedData> &nextState) { this->nextState = &nextState; };
                virtual void onLoad(SharedData &data);
                virtual void run();
                virtual State<SharedData> &getNextState();
                virtual SharedData &onUnload();
        };
    }
}


#endif  // __CONFIGUREDAYSSTATE_H__

