

#include "ConfigureDaysState.H"


using namespace avelino;
using namespace std;


ConfigureDaysState::ConfigureDaysState(Keypad &keypad, SevenSegments &sevenSegments, Stepper &stepper)  : keypad(keypad), sevenSegments(sevenSegments), stepper(stepper), nextState(nullptr) {
    this->stepper.stop();
    this->configureButtonPressed = false;
}


void ConfigureDaysState::onLoad(SharedData &data) {
    this->data = &data;
    this->sevenSegments.setValue(this->data->days);
    this->stepper.stop();
    this->configureButtonPressed = false;
}


void ConfigureDaysState::run() {
    uint32_t k = this->keypad.getKeyMask();
    this->keypad.consume();
    if (k & Keypad::CONFIG_BUTTON)
        this->configureButtonPressed = true;
    else if (k & Keypad::DEC_BUTTON) {
        if (this->data->days > 1) {
            this->data->days--;
            this->sevenSegments.setValue(this->data->days);
        }
    }
    else if (k & Keypad::INC_BUTTON) {
        if (this->data->days < 9) {
            this->data->days++;
            this->sevenSegments.setValue(this->data->days);
        }
   }
}


State<SharedData> &ConfigureDaysState::getNextState() {
    if (this->configureButtonPressed)
        return *(this->nextState);
    else
        return *this;
}


SharedData &ConfigureDaysState::onUnload() {
    return *(this->data);
}


