

#ifndef  __CONFIGURESTEPSSTATE_H__
#define  __CONFIGURESTEPSSTATE_H__


#include "State.H"
#include "SharedData.H"
#include "Keypad.H"
#include "SevenSegments.H"
#include "Stepper.H"


extern "C++" {
    namespace avelino {
        using namespace std;

        class ConfigureStepsState : public State<SharedData>, public StepperListener {
            protected:
                Keypad &keypad;
                SevenSegments &sevenSegments;
                Stepper &stepper;
                State<SharedData> *nextState;
                SharedData *data;
                bool configureButtonPressed;
                enum class Status { STOPPED, RUNNING_CLOCK, RUNNING_COUNTERCLOCK };
                Status status;
                int32_t stepsCounter;
            public:
                ConfigureStepsState(Keypad &keypad, SevenSegments &sevenSegments, Stepper &stepper);
                void setNextState(State<SharedData> &nextState) { this->nextState = &nextState; };
                virtual void stepDone(Stepper &s);
                virtual void onLoad(SharedData &data);
                virtual void run();
                virtual State<SharedData> &getNextState();
                virtual SharedData &onUnload();
                virtual const uint32_t getTicksPerStep() const = 0;
        };
    }
}


#endif  // __CONFIGURESTEPSSTATE_H__

