

#ifndef  __IDLESTATE_H__
#define  __IDLESTATE_H__


#include "State.H"
#include "SharedData.H"
#include "Keypad.H"
#include "SevenSegments.H"
#include "StepperPathManager.H"


extern "C++" {
    namespace avelino {
        using namespace std;

        class IdleState : public State<SharedData> {
            protected:
                Keypad &keypad;
                SevenSegments &sevenSegments;
                State<SharedData> *nextState;
                SharedData *data;
                StepperPathManager stepperPathManager;
                bool configureButtonPressed;
            public:
                IdleState(Keypad &keypad, SevenSegments &sevenSegments, Stepper &stepper);
                void setNextState(State<SharedData> &nextState) { this->nextState = &nextState; };
                virtual void onLoad(SharedData &data);
                virtual void run();
                virtual State<SharedData> &getNextState();
                virtual SharedData &onUnload();
                virtual const uint32_t getTicksPerDay() const = 0;
        };
    }
}


#endif  // __IDLESTATE_H__
