

#ifndef  __KEYPAD_H__
#define  __KEYPAD_H__


#include <stdint.h>
#include "Task.H"


extern "C++" {
    namespace avelino {
        using namespace std;

        class Keypad : public Task {
            protected:
                uint32_t timer;
                enum class Status { IDLE, WAIT_AFTER_CHANGE };
                Status status;
                uint8_t keyMask;
            public:
                static const uint8_t CONFIG_BUTTON = 0x04;
                static const uint8_t DEC_BUTTON    = 0x02;
                static const uint8_t INC_BUTTON    = 0x01;
                Keypad() : status(Status::IDLE), keyMask(0) { };
                void init() { this->gpioConfigure(); };
                virtual void run();
                uint8_t getKeyMask() const { return this->keyMask; };
                void consume() { this->keyMask = 0; };
                virtual void gpioConfigure() const = 0;
                virtual uint8_t getGpioMask() const = 0;    // 1 = pressed, 0 = not pressed, 1 bit = 1 button
                virtual const uint32_t getTicksAfterChange() const = 0;
        };
    }
}


#endif  // __KEYPAD_H__
