

#include "SevenSegments.H"


using namespace std;
using namespace avelino;


const uint8_t SevenSegments::NUMBER_MASKS[10] = {
    // 0        1           2           3           4           5           6           7           8           9
    0b00111111, 0b00000110, 0b01011011, 0b01001111, 0b01100110, 0b01101101, 0b01111101, 0b00000111, 0b01111111, 0b01101111   // '0' based
};
const uint8_t SevenSegments::LETTER_MASKS[10] = {
    // a        b           c           d           e            f           g (' ')     h           i           j
    0b01110111, 0b01111100, 0b01011000, 0b01011110, 0b011111001, 0b01110001, 0b00000000, 0b01010110, 0b00000100, 0b00001110
};


void SevenSegments::init() {
    this->gpioConfigure();
    this->gpioWrite(0);    // all segments off
    this->setValue(' ');
}


void SevenSegments::setValue(char c) {
    if ((c >= '0') && (c <= '9'))
        this->currentMask = NUMBER_MASKS[c - '0'];
    else if ((c >= 'a') && (c <= 'j'))
        this->currentMask = LETTER_MASKS[c - 'a'];
    else
        this->currentMask = 0;
}


void SevenSegments::setValue(uint32_t v) {
    if (v <= 9)
        this->currentMask = NUMBER_MASKS[v];
    else
        this->currentMask = 0;
}


void SevenSegments::run() {
    uint8_t mask = this->currentMask;
    this->gpioWrite(mask);
}

