

#ifndef  __STEPPERPATHMANAGER_H__
#define  __STEPPERPATHMANAGER_H__


#include "Task.H"
#include "Stepper.H"


extern "C++" {
    namespace avelino {
        using namespace std;

        class StepperPathManager : public Task, public StepperListener {
            protected:
                Stepper &stepper;
                int32_t currentStep;
                uint32_t ticksToZero;
                enum class Status { STOPPED, RUNNING };
                Status status;
            public:
                StepperPathManager(Stepper &s) : stepper(s), currentStep(0), ticksToZero(0), status(Status::STOPPED) { this->stepper.stop(); };
                void start(int32_t currentStep, uint32_t ticksToZero);
                void stop();
                virtual void run();
                // StepperListener
                virtual void stepDone(Stepper &s);
        };
    }
}


#endif  // __STEPPERPATHMANAGER_H__
