

//#include <iostream>
#include "StepperPathManager.H"


using namespace avelino;
using namespace std;


void StepperPathManager::start(int32_t currentStep, uint32_t ticksToZero) {
    this->currentStep = currentStep;
    this->ticksToZero = ticksToZero;
    this->status = Status::STOPPED;
    this->stepper.setListener(*this);
    this->stepper.stop();
}


void StepperPathManager::stop() {
    this->currentStep = 0;
}


void StepperPathManager::stepDone(Stepper &s) {
    if (this->currentStep > 0)
        this->currentStep--;
    else if (this->currentStep < 0)
        this->currentStep++;
    //cout << "StepperPathManager::stepDone: currentStep=" << this->currentStep << endl;
}


void StepperPathManager::run() {
    Status localStatus = this->status;
    do {
        this->status = localStatus;
        if (localStatus == Status::STOPPED) {
            if (this->currentStep != 0) {
                int32_t ticksPerStep;
                if (this->currentStep > 0) {
                    ticksPerStep = this->ticksToZero / this->currentStep;
                    this->stepper.setWise(Stepper::Wise::COUNTERCLOCK);
                }
                else {
                    ticksPerStep = this->ticksToZero / -this->currentStep;
                    this->stepper.setWise(Stepper::Wise::CLOCK);
                }
                this->stepper.setTicksPerStep(ticksPerStep);
                this->stepper.start();
                localStatus = Status::RUNNING;
            }
        }
        else if (localStatus == Status::RUNNING) {
            if (this->currentStep == 0) {
                this->stepper.stop();
                localStatus = Status::STOPPED;
            }
        }
    } while (localStatus != this->status);
}

