

#include "Heartbeat.H"


using namespace avelino;
using namespace std;


#define  RCU_APB2EN   *((uint32_t *) 0x40021018)
#define  GPIOA_CTL0   *((uint32_t *) 0x40010800)
#define  GPIOA_OCTL   *((uint32_t *) 0x4001080C)


Heartbeat::Heartbeat() : timer(0) {
	// enable clock on port A
	RCU_APB2EN = RCU_APB2EN | (((uint32_t) 1) << 2);
    // configure A2 (blue led) as push/pull output
    GPIOA_CTL0 = (GPIOA_CTL0 & 0xFFFFF0FF) | 0x00000200;
}


void Heartbeat::run() {
    if (this->timer == 0) {
        const uint32_t MASK = ((uint32_t) 1) << 2;
        if (GPIOA_OCTL & MASK)
            GPIOA_OCTL &= ~MASK;
        else
            GPIOA_OCTL |= MASK;
        this->timer = TIMER_MAX;
    }
    this->timer--;
}

