

#include "MyKeypad.H"


using namespace avelino;
using namespace std;


#define  RCU_APB2EN   *((volatile uint32_t *) 0x40021018)
#define  GPIOB_CTL1   *((volatile uint32_t *) 0x40010C04)
#define  GPIOB_ISTAT  *((volatile uint32_t *) 0x40010C08)


void MyKeypad::gpioConfigure() const {
	// enable clock on port B
	RCU_APB2EN = RCU_APB2EN | (((uint32_t) 1) << 3);
    // enable floating input on B12, B13 and B14
    GPIOB_CTL1 = (GPIOB_CTL1 & 0xF000FFFF) | 0x04440000;
}


uint8_t MyKeypad::getGpioMask() const {
    uint32_t v = GPIOB_ISTAT;
    if ((v & (((uint32_t) 1) << 12)) == 0)
        return Keypad::CONFIG_BUTTON;
    else if ((v & (((uint32_t) 1) << 13)) == 0)
        return Keypad::DEC_BUTTON;
    else if ((v & (((uint32_t) 1) << 14)) == 0)
        return Keypad::INC_BUTTON;
    else
        return 0;
}


const uint32_t MyKeypad::getTicksAfterChange() const {
    return 100;
}

