

#include "MySevenSegments.H"


using namespace avelino;
using namespace std;


#define  RCU_APB2EN   *((uint32_t *) 0x40021018)
#define  GPIOA_CTL0   *((uint32_t *) 0x40010800)
#define  GPIOA_OCTL   *((uint32_t *) 0x4001080C)
#define  GPIOB_CTL0   *((uint32_t *) 0x40010C00)
#define  GPIOB_CTL1   *((uint32_t *) 0x40010C04)
#define  GPIOB_OCTL   *((uint32_t *) 0x40010C0C)
#define  GPIOC_CTL1   *((uint32_t *) 0x40011004)
#define  GPIOC_OCTL   *((uint32_t *) 0x4001100C)


void MySevenSegments::gpioConfigure() const {
	// enable clock on port A, B and C
	RCU_APB2EN = RCU_APB2EN | (((uint32_t) 7) << 2);
    // enable push/pull output on A3 and A4
    GPIOA_CTL0 = (GPIOA_CTL0 & 0xFFF00FFF) | 0x00022000;
    // enable push/pull output on B6, B7 and B8
    GPIOB_CTL0 = (GPIOB_CTL0 & 0x00FFFFFF) | 0x22000000;
    GPIOB_CTL1 = (GPIOB_CTL1 & 0xFFFFFFF0) | 0x00000002;
    // enable push/pull output on C14 and C15
    GPIOC_CTL1 = (GPIOC_CTL1 & 0x00FFFFFF) | 0x22000000;
}


void MySevenSegments::gpioWrite(uint8_t mask) const {
    // a = A4
    if (mask & 0x01)
        GPIOA_OCTL |= ((uint32_t) 1) << 4;
    else
        GPIOA_OCTL &= ~(((uint32_t) 1) << 4);
    // b = A3
    if (mask & 0x02)
        GPIOA_OCTL |= ((uint32_t) 1) << 3;
    else
        GPIOA_OCTL &= ~(((uint32_t) 1) << 3);
    // c = B6
    if (mask & 0x04)
        GPIOB_OCTL |= ((uint32_t) 1) << 6;
    else
        GPIOB_OCTL &= ~(((uint32_t) 1) << 6);
    // d = B7
    if (mask & 0x08)
        GPIOB_OCTL |= ((uint32_t) 1) << 7;
    else
        GPIOB_OCTL &= ~(((uint32_t) 1) << 7);
    // e = B8
    if (mask & 0x10)
        GPIOB_OCTL |= ((uint32_t) 1) << 8;
    else
        GPIOB_OCTL &= ~(((uint32_t) 1) << 8);
    // f = C15
    if (mask & 0x20)
        GPIOC_OCTL |= ((uint32_t) 1) << 15;
    else
        GPIOC_OCTL &= ~(((uint32_t) 1) << 15);
    // g = C14
    if (mask & 0x40)
        GPIOC_OCTL |= ((uint32_t) 1) << 14;
    else
        GPIOC_OCTL &= ~(((uint32_t) 1) << 14);
}

