

#ifndef  __TIMER_H__
#define  __TIMER_H__


#include <stdint.h>
#include "interrupt.H"


#define  MTIME_1_SEC     24000000     // 24 MHz, so for 1 sec we need 24000000 cycles
#define  MTIME_MSEC(ms)  (((uint64_t) 24000) * (ms))


extern "C++" {
	namespace avelino {
		using namespace std;

		class TimerListener {
			public:
				virtual void timerExpired() = 0;
		};

		uint64_t operator "" _msForTimer(unsigned long long v);

		uint64_t operator "" _usForTimer(unsigned long long v);

		class Timer {
			public:
				static uint64_t interval;
				static TimerListener *listener;
				static void init(TimerListener &listener, uint64_t interval = 1000_msForTimer);
				static void interrupt()  __attribute__ ((interrupt, section(TMR_INT_SECTION)));
		};
	}
}


#endif  // __TIMER_H__
