

#include "Timer.H"


using namespace avelino;
using namespace std;


#define  MTIME       *((volatile uint64_t *) 0xD1000000)
#define  MTIMECMP    *((volatile uint64_t *) 0xD1000008)


uint64_t Timer::interval = MTIME_1_SEC;
TimerListener *Timer::listener = nullptr;


uint64_t avelino::operator "" _msForTimer(unsigned long long v) {
	return ((uint64_t) 24000) * v;
}


uint64_t avelino::operator "" _usForTimer(unsigned long long v) {
	return ((uint64_t) 24) * v;
}


void Timer::init(TimerListener &listener, uint64_t interval) {
	Timer::interval = interval;
	Timer::listener = &listener;
	CLIC_ATTR(TMR_INT) = 0b11000001;    // machine mode, level triggered, vectored
	CLIC_IE(TMR_INT) = 1;               // enable interrupt TMR_INT
	CLIC_IP(TMR_INT) = 0;               // not pending
	CLIC_CTL(TMR_INT) = 0;              // priority
	// configure interrupt period
	MTIME = 0;
	MTIMECMP = Timer::interval;
}


void Timer::interrupt() {
	MTIME = 0;
	MTIMECMP = Timer::interval;
	if (Timer::listener != nullptr)
		Timer::listener->timerExpired();
	CLIC_IP(TMR_INT) = 0;    // not pending
}

