

#ifndef  __INTERRUPT_H__
#define  __INTERRUPT_H__


#include <stdint.h>


#define  CLIC_BASE                    0xD2000000
#define  CLIC_IP(source)              *((volatile uint8_t *) (CLIC_BASE + 0x00001000 + ((source) * 4)))
#define  CLIC_IE(source)              *((volatile uint8_t *) (CLIC_BASE + 0x00001001 + ((source) * 4)))
#define  CLIC_ATTR(source)            *((volatile uint8_t *) (CLIC_BASE + 0x00001002 + ((source) * 4)))
#define  CLIC_CTL(source)             *((volatile uint8_t *) (CLIC_BASE + 0x00001003 + ((source) * 4)))


#define  TMR_INT             7
#define  TMR_INT_SECTION     ".clic_int_tmr"
#define  SPI0_INT            54
#define  SPI0_INT_SECTION    ".clic_int_spi0"
#define  USART0_INT          56
#define  USART0_INT_SECTION  ".clic_int_usart0"


extern "C++" {
	namespace avelino {
		void interruptInit();
	}
}


#endif  // __INTERRUPT_H__
