

#include "interrupt.H"


using namespace std;
using namespace avelino;


#define  CLIC_CFG                     *((volatile uint8_t *) (CLIC_BASE + 0x00000000))
#define  CLIC_MTH                     *((volatile uint8_t *) (CLIC_BASE + 0x0000000B))
#define  CLIC_IP_IE_ATTR_CTL(source)  *((volatile uint32_t *) (CLIC_BASE + 0x00001000 + ((source) * 4)))


void avelino::interruptInit() {
	// clear CLIC config register and set vectored interrupts
	CLIC_CFG = 0;
	CLIC_MTH = 0;   // specific register for GD32VF103 ECLIC
	for (uint16_t i = 0; i < 4096; i++)
		CLIC_IP_IE_ATTR_CTL(i) = 0;
	// use CLIC vectored interrupt handler (put 1 on mode (lower two) bits of mtvec)
	asm volatile (
		"csrw mtvec, %[reg]" : : [reg] "r" (0x00000003)
	);
	// machine interrupt enable
	asm volatile (
		"csrsi mstatus, 8"
	);
	// set CLIC interrupt vector table (mtvt = 0x307)
	asm volatile (
		"csrw 0x307, %[reg]" : : [reg] "r" (0x08000000)
	);
}

