

#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include "MyKeypad.H"
#include "vt.H"


using namespace avelino;
using namespace std;


void MyKeypad::gpioConfigure() const {
    struct termios t;
    tcgetattr(0, &t);
    t.c_iflag &= ~(IGNBRK | BRKINT | PARMRK | ISTRIP | INLCR | IGNCR | ICRNL | IXON);
    /* t.c_oflag &= ~OPOST; */
    t.c_lflag &= ~(ECHO | ECHONL | ICANON | ISIG | IEXTEN);
    t.c_cflag &= ~(CSIZE | PARENB);
    t.c_cflag |= CS8;
    tcsetattr(0, TCSANOW, &t);
    fcntl(0, F_SETFL, O_NONBLOCK);
}


uint8_t MyKeypad::getGpioMask() const {
    int n;
    long int data;
    ioctl(0, TIOCINQ, &n);
    uint8_t ret = 0;
    if (n > 0) {
        data = 0;
        read(0, &data, n);
        if (data == 'a')
            return Keypad::CONFIG_BUTTON;
        else if (data == 's')
            return Keypad::DEC_BUTTON;
        else if (data == 'd')
            return Keypad::INC_BUTTON;
        else if (data == 'q') {
            vtReset();
            exit(0);
        }
    }
    return ret;
}


const uint32_t MyKeypad::getTicksAfterChange() const {
    return 100;
}

