

#include <iostream>
#include "vt.H"
#include "MyStepper.H"


using namespace avelino;
using namespace std;


void MyStepper::gpioConfigure() const {
}


void MyStepper::gpioWrite(uint32_t mask) const {
    vtSaveCursor();
    vtGotoXY(20, 1);
    cout << "[ ";
    for (uint32_t aux = 1; aux <= 8; aux <<= 1) {
        if (mask & aux)
            cout << "X ";
        else
            cout << "- ";
    }
    cout << "]";
    vtRestoreCursor();
}


uint32_t MyStepper::getNextMask(uint32_t prevMask, Wise wise) const {
    if (wise == Stepper::Wise::CLOCK)
        return ((prevMask << 1) | ((prevMask >> 3) & 1)) & 0x0F;
    else
        return ((prevMask >> 1) | ((prevMask & 1) << 3)) & 0x0F;
}


const uint32_t MyStepper::getStepsPerRevolution() const {
    return 4076;
}


const uint32_t MyStepper::getTicksPerPulse() const {
    return 10;
}

